/*****************************************************************************
 * Bison/Flexプログラム部分をテストするための、Windowsアプリケーションの雛型 *
 * □ビルド・実行方法:                                                       *
 * ┃"C:\Program Files (x86)\Microsoft Visual Studio\VC98\Bin\VCVARS32.BAT"  *
 * ┃make -f winapp.mk run                                                   *
 *****************************************************************************/
#include "winapp.h"
/*---------------------------------------------------------------------------*/
#define Label_Max	1048576		//ラベル登録最大数		//調整可
#define Inst_Max	4194304		//命令登録最大数		//調整可
typedef struct _ST_Inst {
	uint32_t		line;		//行番号				//1パス目で格納する。エラーメッセージのためだけに使用する。
	uint8_t			len;		//命令コード長				//1パス目で格納する。1～7。
	uint8_t			op[7];		//命令コード				//1パス目で格納する。相対位置フィールドは2パス目で設定する。
	union {
	  char*			labName;	//相対位置ラベル名			//相対位置フィールドが有る命令の場合のみ1パス目で格納する。
	  struct _ST_Inst*	labInst;	//相対位置ラベルが指す命令へのポインタ	//2パス目でlabName⇒labInstに変換する。
	} lab;
	struct _ST_Inst*	redir;		//リダイレクト先の命令へのポインタ	//2パス目で最適化を行い命令を削除した場合に、リダイレクト先の命令へのポインタを格納する。
	uint32_t		addr;		//アドレス				//2パス目で計算する。
} ST_Inst;
static ST_Inst TBL_Inst[Inst_Max + 1];		//命令配列				//'+1'は最後のアドレスを格納するため。
static int nInst;				//命令配列の格納数
static char* TBL_Label[Label_Max];		//ラベル配列
static int nLabel;				//ラベル配列の格納数
static int nAtmarkLocalLabel;			//'@'ローカルラベルの出現数		//'def @@'が出現したら、'@%d'という形式の内部ローカルラベルに変換して、ハッシュテーブルに登録する。その後、+1する。要するに、次に出現する'@'ローカルラベルの番号を表していると見なせるので、'goto @F'や'call @F'からは、nAtmarkLocalLabelで参照できる。'goto @B'や'call @B'からは、(nAtmarkLocalLabel-1)で参照できる。
static char* sDotLocalLabelPrefix = "";		//'.'ローカルラベルのプレフィクス	//'def .～'が出現したら、'%s.～'という形式の内部ローカルラベルに変換して、ハッシュテーブルに登録する。グローバルラベルの定義が出現したら、sDotLocalLabelPrefixを更新する。結果として、グローバルラベル定義～グローバルラベル定義の間でのローカルラベルとなる。
//{{進捗表示用
static int newMsgLen, oldMsgLen = 0;
//}}進捗表示用
/*---------------------------------------------------------------------------*/
//エラーログ用
static char err_path[_MAX_PATH];	//'-e'オプションが指定されたら、エラーログファイル名を格納する。
static FILE* fp_err;			//最初のエラーログを記録する時に、エラーログファイルを作成する。
void yyerror(const char* fmt, ...) {	//←{{2015/03/06:'-e'オプション対応のためにwinapp.cから移動しました。}}
	//'-e'オプションが指定されていて、最初のエラーログを記録する時ならば…
	if(*err_path && !fp_err) {
		//エラーログファイルを作成する。
		fp_err = fopen(err_path, "w");
		if(!fp_err) { die("%s が作成できません。\n", err_path); }
		//エラーログファイルの出力ストリームは、バッファリング無しとする。
		// - die()で終了した時(abort()時)に、バッファ分がフラッシュされないようなので、こうしておく必要が有る。
		//   別の案として、この下の処理で毎回fflush()する方法も有るが、バッファリング無しとする方が簡単だろう。
		setbuf(fp_err, NULL);
	}
	//エラーメッセージ(,及び,エラーログ)を出力する。
	             fprintf(stderr, "### error at line %d : ", yylineno);	//エラーメッセージ
	if(fp_err) { fprintf(fp_err, "### error at line %d : ", yylineno); }	//エラーログ
	{
		va_list ap;
		va_start(ap, fmt);
		             vfprintf(stderr, fmt, ap);		//エラーメッセージ
		if(fp_err) { vfprintf(fp_err, fmt, ap); }	//エラーログ
		va_end(ap);
	}
	             fputc('\n', stderr);	//エラーメッセージ
	if(fp_err) { fputc('\n', fp_err); }	//エラーログ
}
/*---------------------------------------------------------------------------*/
/* ローカル関数宣言 */
__declspec(noreturn) static void usage();
static ST_Inst* add_inst();
static ST_Inst* getRedir(ST_Inst* pInst);
static void pass2(int bOptimize);
static void output(char* sPrefix, char* sBinOut);
static void optimize();
/*---------------------------------------------------------------------------*/
int main(int argc, char* argv[]) {
	int opt, bOptimize = 1;	//'-d'オプションが指定されなければ最適化を行う。
	char* sPrefix = "";	//'-p'オプションが指定されたらプレフィクス文字列を設定する。
	char* sBinOut = NULL;	//'-o'オプションが指定されたらバイナリ出力ファイル名を設定する。
#if     (YYDEBUG!=0)
//	yydebug = 1; //nonzero means print parse trace
#endif/*(YYDEBUG!=0)*/
	//コマンドラインオプションを処理する。
	opterr = 0; //オプションエラーは当プログラム内で処理するので、getopt()内でのエラー表示は不要。
	while((opt = getopt(argc, argv, "dp:o:eh")) != -1) {
		switch(opt) {
		case 'd':
			bOptimize = 0;		//最適化を行わない。
			break;
		case 'p':
			sPrefix = optarg;	//プレフィクス文字列を設定する。
			break;
		case 'o':
			sBinOut = optarg;	//バイナリ出力ファイル名を設定する。
			break;
		case 'e':
			{
				//エラーログファイル名を作成する。
				// - カレントフォルダに'実行ファイル名.err'という名前で生成する事にした。この動作は、'lk33.exe'の仕様を参考にした。
				char fname[_MAX_FNAME];
				_splitpath(argv[0], NULL, NULL, fname, NULL);
				_makepath(err_path, NULL, NULL, fname, ".err");
				//'-e'オプションが指定されたら、最初に確実に、既存のエラーログファイルを削除しておく。
				//前回に生成したエラーログが残っていて、今回生成したエラーログと混同する危険を避けるためである。
				//尚、'-e'オプションが指定されなかった場合は、既存のエラーログファイルを削除する処理は行わない。
				remove(err_path);
			}
			break;
		case 'h':
		default:
			usage();
		}
	}
	//ラベルを登録するためのハッシュテーブルを作成する。
	hcreate(Label_Max);
	//判り易さのために、命令位置0は使用しないことにした。命令位置0には、ダミーのend命令を置くことにした。
	inst_end();
	//--- 1パス目の処理 ---
	//ファイルが指定されていなければ、標準入力から読み込む。
	if(optind == argc) {
		yylex_init(stdin);
	    //{{2015/02/23修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
	    //	if((yyparse() != 0) || (yynerrs != 0)) { die("エラーが発生しました。\n"); }
	    //↓2015/02/23修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
		if((yyparse() != 0) /*|| (yynerrs != 0)*/) { die("エラーが発生しました。\n"); }
	    //}}2015/02/23修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
	//ファイルが指定されていたら、各ファイルを読み込む。
	} else {
		int i;
		for(i = optind; i < argc; i++) {
			FILE* fp = fopen(argv[i], "r");
			if(!fp) { die("%s が開けません。\n", argv[i]); }
			yylex_init(fp);
		    //{{2015/02/23修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
		    //	if((yyparse() != 0) || (yynerrs != 0)) { die("%s: エラーが発生しました。\n", argv[i]); }
		    //↓2015/02/23修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
			if((yyparse() != 0) /*|| (yynerrs != 0)*/) { die("%s: エラーが発生しました。\n", argv[i]); }
		    //}}2015/02/23修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
			fclose(fp);
		}
	}
	//安全のために、最後にendが無かった場合は、自動的にendを補う事にした。
	if(TBL_Inst[nInst - 1].op[0]) {	//命令位置0にダミーのend命令を置いたので、ここで(nInst>=1)は保証できる。
		inst_end();
	}
    //{{進捗表示用
	newMsgLen = fprintf(stderr, "\rラベル %d個", nLabel);
	if(oldMsgLen > newMsgLen) { fprintf(stderr, "%*s", oldMsgLen - newMsgLen, ""); } putc('\n', stderr); oldMsgLen = 0;
    //}}進捗表示用
	//1パス目の処理でエラーが発生しても、2パス目の処理を行って、全てのセマンティクスエラーを報告する。
	//--- 2パス目の処理 ---
	//2パス目の処理を行う。
	pass2(bOptimize);
	if(yynerrs != 0) { die("エラーが発生しました。\n"); }	//1パス目,又は,2パス目の処理でエラーが発生していたら、出力処理を行わない。
	//--- 出力処理 ---
	//出力処理を行う。
	output(sPrefix, sBinOut);
	if(yynerrs != 0) { die("エラーが発生しました。\n"); }
	return EXIT_SUCCESS;
}
/*---------------------------------------------------------------------------*/
//使い方を表示して終了する。
__declspec(noreturn) static void usage() {
	fprintf(stderr, "dDirSeqC - 演出シーケンサコンパイラ (%s)\n", VERSION);
	fprintf(stderr, "Copyright (C) 2015 Naoyuki Sawa\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "USAGE:\n");
	fprintf(stderr, "  dDirSeqC [option ...] [filename ...] \n");
	fprintf(stderr, "  ・filenameを指定しなければ、標準入力から読み込みます。\n");
	fprintf(stderr, "  ・filenameは、ワイルドカードによる複数指定も可能です。\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "OPTIONS:\n");
	fprintf(stderr, "  -d           最適化を行いません。\n");
	fprintf(stderr, "               このオプションを指定しなければ、最適化を行います。\n");
	fprintf(stderr, "  -p文字列     ラベルに、プレフィクス文字列を追加します。\n");
	fprintf(stderr, "               このオプションを指定しなければ、プレフィクス文字列を追加しません。\n");
	fprintf(stderr, "  -oファイル名 演出制御のバイナリデータを、バイナリ形式でファイルへ出力します。\n");
	fprintf(stderr, "               このオプションを指定しなければ、Cソース形式で標準出力へ出力します。\n");
	fprintf(stderr, "               このオプションの指定に関らず、ラベルは常に標準出力へ出力します。\n");
	fprintf(stderr, "  -e           エラーログファイルを生成します。\n");
	fprintf(stderr, "               このオプションを指定しても、エラーが発生しなければ生成されません。\n");
	fprintf(stderr, "  -h           使い方を表示します。\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "EXAMPLE:\n");
	fprintf(stderr, "  ①dDirSeqC.exe -pDirTblNo_ DirSeq.csv > DirSeq.c\n");
	fprintf(stderr, "  　DirSeq.csvをコンパイルして、DirSeq.cへ出力します。\n");
	fprintf(stderr, "  　ラベルのプレフィクス文字列として、DirTblNo_を追加します。\n");
	fprintf(stderr, "  ②dDirSeqC.exe -pDirTblNo_ -oDirSeq.bin DirSeq.csv > DirSeq.h\n");
	fprintf(stderr, "  　DirSeq.csvをコンパイルして、ラベルをDirSeq.hへ出力します。\n");
	fprintf(stderr, "  　演出制御のバイナリデータを、DirSeq.binへ出力します。\n");
	exit(EXIT_FAILURE);
}
/*---------------------------------------------------------------------------*/
//1パス目の処理
static ST_Inst* add_inst() {
	ST_Inst* pInst;
	if((unsigned)nInst >= Inst_Max) {
		yyerror("命令数が制限を超えました。(%d)", Inst_Max);
		exit(EXIT_FAILURE);
	}
	pInst = &TBL_Inst[nInst++];
	pInst->line = yylineno;		//行番号
	return pInst;
}
void inst_def(char* lab) {
	ENTRY item;
    //{{ローカルラベルの処理
	if(lab[0] == '@') {
		if(lab[1] == '@') {	//'@@'
			lab = strdup_printf("@%d", nAtmarkLocalLabel++);	//内部ローカルラベルに変換して、ハッシュテーブルに登録する。その後、+1する。
		} else {		//'@B','@F'
			yyerror("defのラベル定義が不正です。(%s)", lab);
			yynerrs++;	//呼び出し元(main)に知らせるために
			//全てのセマンティクスエラーを報告するために継続する
		}
	} else if(lab[0] == '.') {
		lab = strconcat(sDotLocalLabelPrefix, lab, NULL);		//内部ローカルラベルに変換して、ハッシュテーブルに登録する。
	} else {
		sDotLocalLabelPrefix = lab;					//グローバルラベルの定義が出現したら、sDotLocalLabelPrefixを更新する。
	}
    //}}ローカルラベルの処理
	item.key = lab;
	if(hsearch(item, FIND)) {
		yyerror("defのラベル定義が重複しています。(%s)", lab);
		yynerrs++;	//呼び出し元(main)に知らせるために
		//全てのセマンティクスエラーを報告するために継続する
	}
	item.data = &TBL_Inst[nInst];
	if(!hsearch(item, ENTER)) {
		yyerror("ラベル数が制限を超えました。(%d)", Label_Max);
		yynerrs++;	//呼び出し元(main)に知らせるために
		//全てのセマンティクスエラーを報告するために継続する
	}
	if((lab[0] == '@') || strchr(lab, '.')) { return; }			//ローカルラベルは出力しない。
	if(nLabel < Label_Max) {
		TBL_Label[nLabel++] = lab;	//hsearch()はイテレーションの機能が無いので、後でイテレートするためにはキー配列を別に作成しておく必要が有る。
	    //{{進捗表示用
		newMsgLen = fprintf(stderr, "\rラベル %d個目 %s", nLabel, lab);
		if(oldMsgLen > newMsgLen) { fprintf(stderr, "%*s", oldMsgLen - newMsgLen, ""); } oldMsgLen = newMsgLen;
	    //}}進捗表示用
	}
}
void inst_end() {
	ST_Inst* pInst = add_inst();
	pInst->op[pInst->len++] = 0x00;//end
}
void inst_repeat(int num) {
	ST_Inst* pInst = add_inst();
	pInst->op[pInst->len++] = 0x01;//repeat
	pInst->op[pInst->len++] = num;
	if(!num || ((unsigned)num >= (unsigned)(1<<8))) {
		yyerror("repeatの引数が範囲外です。(%d)", num);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
}
void inst_wait(int num) {
	ST_Inst* pInst = add_inst();
	pInst->op[pInst->len++] = 0x02;//wait
	pInst->op[pInst->len++] = (uint8_t)(num     );
	pInst->op[pInst->len++] = (uint8_t)(num >> 8);
	if(!num || ((unsigned)num >= (unsigned)(1<<16))) {
		yyerror("waitの引数が範囲外です。(%d)", num);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
}
void inst_call(char* lab) {
	ST_Inst* pInst = add_inst();
	pInst->op[pInst->len++] = 0x03;//call
	pInst->op[pInst->len++] = 0;//┐
	pInst->op[pInst->len++] = 0;//├2パス目で設定する。
	pInst->op[pInst->len++] = 0;//┘
    //{{ローカルラベルの処理
	if(lab[0] == '@') {
		if(lab[1] == 'B') {		//'@B'
			lab = strdup_printf("@%d", nAtmarkLocalLabel - 1);	//'goto @B'や'call @B'からは、(nAtmarkLocalLabel-1)で参照できる。もし'def @@'が出現する前に@Bを参照した場合は-1になってしまうが、2パス目に未定義ラベルとしてエラー検出できるはずであり、安全です。
		} else if(lab[1] == 'F') {	//'@F'
			lab = strdup_printf("@%d", nAtmarkLocalLabel);		//'goto @F'や'call @F'からは、nAtmarkLocalLabelで参照できる。もしこの後に'def @@'が出現しなければ存在しない内部ローカルラベルを参照してしまうが、2パス目に未定義ラベルとしてエラー検出できるはずであり、安全です
		} else {			//'@@'
			yyerror("callのラベル定義が不正です。(%s)", lab);
			yynerrs++;	/* 呼び出し元(main)に知らせるために */
			/* 全てのセマンティクスエラーを報告するために継続する */
		}
	} else if(lab[0] == '.') {
		lab = strconcat(sDotLocalLabelPrefix, lab, NULL);		//内部ローカルラベルに変換して、ハッシュテーブルに登録する。
	}
    //}}ローカルラベルの処理
	pInst->lab.labName = lab;
}
void inst_act(int flush, int num) {
	ST_Inst* pInst = add_inst();
	pInst->op[pInst->len++] = !flush ? 0x04/*act*/ : 0x05/*act flush*/; 
	pInst->op[pInst->len++] = (uint8_t)(num      );
	pInst->op[pInst->len++] = (uint8_t)(num >>  8);
	pInst->op[pInst->len++] = (uint8_t)(num >> 16);
	if((unsigned)num >= (unsigned)(1<<24)) {
		yyerror("actの引数が範囲外です。(%d)", num);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
}
void inst_on(int unlock, int trig, char* lab, int lock) {
	ST_Inst* pInst = add_inst();
	pInst->op[pInst->len++] = !unlock ? 0x06/*on*/ : 0x07/*on unlock*/; 
	pInst->op[pInst->len++] = trig;
	pInst->op[pInst->len++] = 0;//┐
	pInst->op[pInst->len++] = 0;//├2パス目で設定する。
	pInst->op[pInst->len++] = 0;//┘
	pInst->op[pInst->len++] = (uint8_t)(lock     );
	pInst->op[pInst->len++] = (uint8_t)(lock >> 8);
    //{{ローカルラベルの処理
	if(lab[0] == '@') {
		if(lab[1] == 'B') {		//'@B'
			lab = strdup_printf("@%d", nAtmarkLocalLabel - 1);	//'goto @B'や'call @B'からは、(nAtmarkLocalLabel-1)で参照できる。もし'def @@'が出現する前に@Bを参照した場合は-1になってしまうが、2パス目に未定義ラベルとしてエラー検出できるはずであり、安全です。
		} else if(lab[1] == 'F') {	//'@F'
			lab = strdup_printf("@%d", nAtmarkLocalLabel);		//'goto @F'や'call @F'からは、nAtmarkLocalLabelで参照できる。もしこの後に'def @@'が出現しなければ存在しない内部ローカルラベルを参照してしまうが、2パス目に未定義ラベルとしてエラー検出できるはずであり、安全です
		} else {			//'@@'
			yyerror("gotoのラベル定義が不正です。(%s)", lab);
			yynerrs++;	/* 呼び出し元(main)に知らせるために */
			/* 全てのセマンティクスエラーを報告するために継続する */
		}
	} else if(lab[0] == '.') {
		lab = strconcat(sDotLocalLabelPrefix, lab, NULL);		//内部ローカルラベルに変換して、ハッシュテーブルに登録する。
	}
    //}}ローカルラベルの処理
	pInst->lab.labName = lab;
	if(((unsigned)trig >= (unsigned)(1<< 8)) ||
	   ((unsigned)lock >= (unsigned)(1<<16))) {
		yyerror("repeatの引数が範囲外です。(%d,%d)", trig, lock);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
}
/*---------------------------------------------------------------------------*/
//NULLが指定された場合、NULLを返す。
//NULL以外が指定された場合、リダイレクト先の命令へのポインタをたどって、末端のポインタを返す。
static ST_Inst* getRedir(ST_Inst* pInst) {
	if(pInst) {
		while(pInst->redir) {
			pInst = pInst->redir;
		}
	}
	return pInst;
}
/*---------------------------------------------------------------------------*/
//2パス目の処理
static void pass2(int bOptimize) {
	int iInst, addr, dist;
	ST_Inst *pInst, *labInst;
	ENTRY item, *pEntry;
	//全ての命令の相対位置ラベル名を、相対位置ラベルが指す命令へのポインタに変換する。
	for(iInst = 0; iInst < nInst; iInst++) {
		pInst = &TBL_Inst[iInst];
		yylineno = pInst->line;		//yyerrorのために
		//相対位置ラベル名が有れば…
		if(pInst->lab.labName) {
			//ラベルが定義されていたら…
			item.key = pInst->lab.labName;
			if((pEntry = hsearch(item, FIND))) {
				//相対位置ラベルが指す命令へのポインタを格納する。
				pInst->lab.labInst = pEntry->data;
			//ラベルが定義されていなければ…
			} else {
				yyerror("ラベルが未定義です。(%s)", pInst->lab);
				yynerrs++;	//呼び出し元(main)に知らせるために
				//全てのセマンティクスエラーを報告するために継続する
				pInst->lab.labInst = &TBL_Inst[0];	//この後の処理が継続できるように、ダミーとして命令位置0を指しておく。
			}
		}
	}
	//最適化を行う。
	if(bOptimize) { optimize(); }
	//アドレスを計算する。
	addr = 0;
	for(iInst = 0; iInst < nInst + 1; iInst++) {	//'+1'は最後のアドレスを格納するため。
		pInst = &TBL_Inst[iInst];
		pInst->addr = addr;
		addr += pInst->len;	//最適化によって削除された命令ならば(pInst->len==0)になっているのでaddrは進まない。
	}
	//相対位置フィールドの設定を行う。
	for(iInst = 0; iInst < nInst; iInst++) {
		pInst = &TBL_Inst[iInst];
		yylineno = pInst->line;		//yyerrorのために
		//最適化によって削除された命令でなければ…
		if(pInst->len) {
			//相対位置ラベルが指す命令へのポインタが有れば…
			if(pInst->lab.labInst) {
				labInst = getRedir(pInst->lab.labInst);
				dist = labInst->addr - (pInst + 1)->addr;	//'+1'は次の命令の位置を基準とするため。
				switch(pInst->op[0]) {
				case 0x03://call
					pInst->op[1] = (uint8_t)(dist      );
					pInst->op[2] = (uint8_t)(dist >>  8);
					pInst->op[3] = (uint8_t)(dist >> 16);
					break;
				case 0x06://on
				case 0x07://on unlock
					pInst->op[2] = (uint8_t)(dist      );
					pInst->op[3] = (uint8_t)(dist >>  8);
					pInst->op[4] = (uint8_t)(dist >> 16);
					break;
				default:DIE();
				}
				if(((int)dist <= (int)(-1<<(24-1))) ||
				   ((int)dist >= (int)( 1<<(24-1)))) {
					yyerror("相対位置が範囲外です。(%s)", dist);
					yynerrs++;	//呼び出し元(main)に知らせるために
					//全てのセマンティクスエラーを報告するために継続する
				}
			}
		}
	}
}
/*---------------------------------------------------------------------------*/
//出力処理
static int Label_compar(const void* x, const void* y) {
	return strcmp(*(char**)x, *(char**)y);
}
static void output(char* sPrefix, char* sBinOut) {
	int iInst, iLabel, i;
	ST_Inst *pInst, *labInst;
	ENTRY item, *pEntry;
	//ラベル定義を名前の昇順にソートする。
	qsort(TBL_Label, nLabel, sizeof(char*), Label_compar);
	//--- ラベルを標準出力に出力する ---
	for(iLabel = 0; iLabel < nLabel; iLabel++) {				//名前の昇順	ラベル=0(ダミー)は定義しない。
		char* label = TBL_Label[iLabel];
		printf("#define %s%s %d\n", sPrefix, label, iLabel + 1);	//ラベルは1ベース
	}
	if(*sPrefix) { printf("#define %sMax %d\n", sPrefix, nLabel); }		//プレフィクス文字列が有る場合のみ最大値を定義する。(プレフィクス文字列が無ければ定義しない。'Max'という単純なマクロ定義になり問題が有るから。)
	//--- データを出力する ---
	//バイナリ形式の場合…
	if(sBinOut) {
		FILE* fp = fopen(sBinOut, "wb");
		if(!fp) { die("%s が作成できません。\n", sBinOut); }
		//アドレステーブルを出力する。
		for(iLabel = -1; iLabel < nLabel; iLabel++) {
			int addr;
			if(iLabel < 0) {
    //{{2015/03/02変更:TBL_DirTblNo[0]に(DirTblNo_Max+1)を格納するようにしました。
    //				addr = 0;					//ラベル番号=0(ダミー)
    //↓2015/03/02変更:TBL_DirTblNo[0]に(DirTblNo_Max+1)を格納するようにしました。
				addr = nLabel + 1;				//TBL_DirTblNo[0]=(DirTblNo_Max+1)	ラベルは1ベースなのでnLabelではなく(nLabel+1)とする事に注意せよ。
    //}}2015/03/02変更:TBL_DirTblNo[0]に(DirTblNo_Max+1)を格納するようにしました。
			} else {
				char* label = TBL_Label[iLabel];
				item.key = label;
				if(!(pEntry = hsearch(item, FIND))) { DIE(); }	//バグ
				labInst = getRedir(pEntry->data);
				addr = labInst->addr;
			}
			fwrite(&addr, sizeof(int), 1, fp);
		}
		//命令コードの出力を行う。
		for(iInst = 0; iInst < nInst; iInst++) {
			pInst = &TBL_Inst[iInst];
			for(i = 0; i < pInst->len; i++) {	//最適化によって削除された命令ならば、(pInst->len=0)になっているので、このループ内の処理を行わない。
				int data = pInst->op[i];
				fwrite(&data, sizeof(unsigned char), 1, fp);
			}
		}
		fclose(fp);
	//テキスト形式の場合…
	} else {
		//アドレステーブルを出力する。
		printf("const int TBL_DirTblNo[%d]={", nLabel + 1);
		for(iLabel = -1; iLabel < nLabel; iLabel++) {
			int addr;
			if(iLabel < 0) {
    //{{2015/03/02変更:TBL_DirTblNo[0]に(DirTblNo_Max+1)を格納するようにしました。
    //				addr = 0;					//ラベル番号=0(ダミー)
    //↓2015/03/02変更:TBL_DirTblNo[0]に(DirTblNo_Max+1)を格納するようにしました。
				addr = nLabel + 1;				//TBL_DirTblNo[0]=(DirTblNo_Max+1)	ラベルは1ベースなのでnLabelではなく(nLabel+1)とする事に注意せよ。
    //}}2015/03/02変更:TBL_DirTblNo[0]に(DirTblNo_Max+1)を格納するようにしました。
			} else {
				char* label = TBL_Label[iLabel];
				item.key = label;
				if(!(pEntry = hsearch(item, FIND))) { DIE(); }	//バグ
				labInst = getRedir(pEntry->data);
				addr = labInst->addr;
			}
			if((iLabel & 15) == 15)    { putchar('\n'); }
			printf("0x%08X", addr);
			if(iLabel != (nLabel - 1)) { putchar(',' ); }
		}
		puts("};");
		//命令コードの出力を行う。
		printf("const unsigned char TBL_DirSeq[%d]={", TBL_Inst[nInst].addr);
		for(iInst = 0; iInst < nInst; iInst++) {
			pInst = &TBL_Inst[iInst];
			for(i = 0; i < pInst->len; i++) {	//最適化によって削除された命令ならば、(pInst->len=0)になっているので、このループ内の処理を行わない。
				int data = pInst->op[i];
				if(   pInst->addr + i       ) { putchar(',' ); }
				if(!((pInst->addr + i) & 31)) { putchar('\n'); }
				printf("0x%02X", data);
			}
		}
		puts("};");
	}
}
/*===========================================================================*
 * 最適化
 *===========================================================================*/
#define Block_Max	(Inst_Max/4)	//ブロック最大数		//調整可
typedef struct _ST_Block {
	int	bDel;		//このブロックを削除したら1にする。
	int	iInst;		//命令配列の何要素目からこのブロックが開始するか
	int	nInst;		//このブロックの命令数
} ST_Block;
ST_Block TBL_Block[Block_Max];	//ブロック配列
int nBlock;			//ブロック配列の格納数
/*---------------------------------------------------------------------------*/
static void optimize() {
	//--- ブロック分割 ---
	{
		//ブロックとは、「先頭,又は,endの次」～(repeat～endのネスト)～「end」の区間である。
		//要するに、一つの演出テーブル,又は,一つの演出シーケンスの事である。
		int iInst, nRepeat = 0;
		for(iInst = 0; iInst < nInst; iInst++) {
			ST_Inst* pInst = &TBL_Inst[iInst];
			switch(pInst->op[0]) {
			case 0x00://end
				//Repeat中ならば…
				if(nRepeat) {
					//Repeatの深さを減らす。
					nRepeat--;
				//Repeat中でなければ…
				} else {
					//現在のブロックを終了する。
					TBL_Block[nBlock].nInst = (iInst + 1) - TBL_Block[nBlock].iInst;	//現在のブロックの命令数を決定する。
					if(++nBlock >= Block_Max) { DIE(); }	//Block_Maxを増やせ
					TBL_Block[nBlock].iInst = (iInst + 1);					//次のブロックの開始インデクスを格納しておく。(最後はダミー)
				}
				break;
			case 0x01://repeat
				//Repeatの深さを増やす。
				nRepeat++;
				break;
			}
		}
		//ブロックを終了した直後以外で命令配列の末尾に到達したら…
		// - 元のスクリプトが間違っていた場合(たとえばendが不足していたりrepeat～endの対応が間違っている場合)、正常にブロック分割できず、最適化を行えない。
		//   正常にブロック分割できないと判断した場合は、最適化を行わないだけでなく、エラーとしてコンパイルを中断する事にした。
		//   必ずしもエラーとしなくても、コンパイルを行ってコードを生成する事は可能だが、実行時に終端を突き抜けて異常動作する可能性が高く、コンパイルエラーで止めておく方が安全だと思ったからです。
		// - どうしてもそのようなスクリプトをコンパイルしたい場合は、'-d'オプションを指定して最適化をオフにしてください。
		if(TBL_Block[nBlock].iInst != nInst) {
			yyerror("ブロックが閉じていません。endが不足しているかrepeat～endの対応が間違っている可能性が有ります。");
			yynerrs++;	//呼び出し元(main)に知らせるために
			return;		//ここまで
		}
	}
	//--- 最適化 ---
	{
		int nOpt, iTry = 0;
		do {
			int iBlock1, iBlock2, i;
			nOpt = 0;	//最適化を行った箇所の数をリセットする。
			iTry++;		//最適化の試行回数を進める。
			for(iBlock1 = 0; iBlock1 < nBlock - 1; iBlock1++) {						//比較元の各ブロックについて…
				ST_Block* pBlock1 = &TBL_Block[iBlock1];
				if(pBlock1->bDel) { continue; }								//比較元のブロックが削除済みならば、この比較元をスキップする。
			    //{{進捗表示用
				newMsgLen = fprintf(stderr, "\r最適化 %d回目 %d箇所 %d/%d", iTry, nOpt, iBlock1, nBlock - 1);
				if(oldMsgLen > newMsgLen) { fprintf(stderr, "%*s", oldMsgLen - newMsgLen, ""); } oldMsgLen = newMsgLen;
			    //}}進捗表示用
				for(iBlock2 = iBlock1 + 1; iBlock2 < nBlock; iBlock2++) {				//比較先の各ブロックについて…
					ST_Block* pBlock2 = &TBL_Block[iBlock2];
					if(pBlock2->bDel) { continue; }							//比較先のブロックが削除済みならば、この比較元をスキップする。
					//比較元のブロックと比較先のブロックを比較する処理。
					if(pBlock1->nInst != pBlock2->nInst) { goto L_NEXT; }				//命令数が違うならば、不一致。
					for(i = 0; i < pBlock1->nInst; i++) {						//各命令について…
						ST_Inst* pInst1 = &TBL_Inst[pBlock1->iInst + i];
						ST_Inst* pInst2 = &TBL_Inst[pBlock2->iInst + i];
						if(pInst1->len != pInst2->len) { goto L_NEXT; }				//命令長が違うならば、不一致。
						if(memcmp(pInst1->op, pInst2->op, pInst1->len)) { goto L_NEXT; }	//バイト値が違うならば、不一致。	相対位置フィールドはまだ0のままで比較する。
						if(getRedir(pInst1->lab.labInst) != getRedir(pInst2->lab.labInst)) { goto L_NEXT; }	//相対位置ラベルが指す命令へのポインタが違うならば、不一致。		getRedir()にはNULLを渡しても安全。両方ともNULLの場合も一致と見なす。
					}
					//ブロックが一致したので、比較先のブロックを、比較元のブロックにリダイレクトする。
					for(i = 0; i < pBlock1->nInst; i++) {					//各命令について…
						ST_Inst* pInst1 = &TBL_Inst[pBlock1->iInst + i];
						ST_Inst* pInst2 = &TBL_Inst[pBlock2->iInst + i];
						pInst2->redir = pInst1;	//比較先の命令を比較元の命令へリダイレクトする。
						pInst2->len = 0;	//比較先の命令を削除する。
					}
					pBlock2->bDel = 1;		//比較先のブロックを削除する。
					nOpt++;				//最適化を行った箇所の数を増やす。
				L_NEXT:	;
				}
			}
		    //{{進捗表示用
			newMsgLen = fprintf(stderr, "\r最適化 %d回目 %d箇所 %d/%d", iTry, nOpt, iBlock1, nBlock - 1);
			if(oldMsgLen > newMsgLen) { fprintf(stderr, "%*s", oldMsgLen - newMsgLen, ""); } putc('\n', stderr); oldMsgLen = 0;
		    //}}進捗表示用
		} while(nOpt);		//一箇所でも最適化を行ったら、それによって別の最適化が可能になった可能性が有るので、繰り替えす。
	}
}
